//////////////////////////////////////////////
//Klasse CircleLine (Kreis) wird erst in dieser 
//Version, in der Schnittpunkte von Geraden eine
//Rolle spielen, von Rectangle abgeleitet. Zuvor waren 
//bis auf Point und Polygon alle Klassen von Line abgeleitet.
//Schnittpunkte bestimmen wir aber nur zwischen Geraden.
//Daher sind nun alle Klassen unterhalb von Line
//zur Schnittpunkt-Bestimmung zugelassen.
///////////////////////////////////////////////////////
public class CircleLine extends Rectangle {
  
  // Anfang Attribute
  private int  x1, y1, x2, y2 ;
  private float r;
 
//Konstruktor  
  public CircleLine(Point point1, Point point2) {
    super(point1, point2);
    this.point1=point1;
    this.point2=point2;
  }
//Überschriebene Methode display()
  public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    x1 = point1.getX();
    y1 = point1.getY();
    x2 = point2.getX();
    y2 = point2.getY();
    r = (float)Math.sqrt((y2-y1)*(y2-y1) + (x2-x1)*(x2-x1));//Radius
    //Eine Ellipse mit gleichgroßen Hauptachsen ist ein Kreis
    ellipseMode(RADIUS);
    noFill();
    ellipse(x1,y1,r,r);
 } 
 
}