//////////////////////////////////////////////////////////////
//Die Winkelhalbierende, definiert durch point1 als Scheitel
//und point3 und point4, die auf den beiden Schenkeln des Winkels
//liegen. Die beiden letztgenannten Punkte werden so verändert,
//dass sie gleichen Abstand zum Scheitel haben. Danach ist nur 
//noch ein bereits bekanntes "Mittelsenkrechten-Problem" zu lösen
/////////////////////////////////////////////////////////////////
public class StraightLineWH extends StraightLineSH{
 
  private int x3Neu, y3Neu, x4Neu, y4Neu;
 
  
  
  public StraightLineWH(Point point1, Point point3, Point point4) {
    super(point1,point3,point4);
    this.point1 = point1;
    this.point3 = point3;
    this.point4 = point4;
    x3= point3.getX(); y3= point3.getY();
    x4= point4.getX(); y4= point4.getY();
    x3Neu= round(xWert(x1,y1,x3,y3));
    y3Neu= round(yWert(x1,y1,x3,y3));
    x4Neu= round(xWert(x1,y1,x4,y4));
    y4Neu= round(yWert(x1,y1,x4,y4));     
    y5= funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,-10);
    y6= funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));
    
  }

  
  float abstand(int x1, int y1, int x2, int y2){
    double d = Math.sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
    return (float) d;
  }
  
  float xWert(int x1, int y1, int x2, int y2){
    float x = x1 + (x2-x1)*100/abstand(x1,y1,x2,y2);
    return x;
  }
  
  float yWert(int x1, int y1, int x2, int y2){
    float y = y1 + (y2-y1)*100/abstand(x1,y1,x2,y2);
    return y;
  }
  
  int funktionWH(int x1, int y1, int x2, int y2,  int x3, int y3, int x){
  float s1 =  float((-2*y1+y2+y3)*x)/float((-2*x1+x2+x3));
  float s2 =  float((-x1*y2+x2*y1+x3*y1-x1*y3))/float((-2*x1+x2+x3));
  float result = s1 + s2;
  return round(result);
}  

  
  public void display(){
   farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);   
    x1= point1.getX(); y1= point1.getY();
    x3= point3.getX(); y3= point3.getY();
    x4= point4.getX(); y4= point4.getY();   
    x3Neu= round(xWert(x1,y1,x3,y3));
    y3Neu= round(yWert(x1,y1,x3,y3));
    x4Neu= round(xWert(x1,y1,x4,y4));
    y4Neu= round(yWert(x1,y1,x4,y4));   
    point7.setY(funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,point7.getX()));
    y5= funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,-10);
    y6= funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,1010);
    point5.setX(-10); point5.setY(round(y5));
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
       stroke(color(150,0,0));
    }
   
    line(-10,y5,1010, y6);
    
   
  if (selected) {
      stroke(farbe);
    }
 }
}