/////////////////////////////////////////////////////////////////////////////////  
//Programm "Dynamische Geometrie" (hier in der Version mit Schnittpunkten,
//VertexCurve und BezierCurve )
//Aufgabe 3a im Kapitel Raeumliche Formen
/////////////////////////////////////////////////////////////////////////////
//Attribute:
////////////////////////////////////////////////////////////////////////
private ArrayList<GeoObject> geoObjects = new ArrayList<GeoObject>();
private ArrayList<Point> selectedPoints= new ArrayList<Point>();
private ArrayList<Point> fixPoints= new ArrayList<Point>();
private ArrayList<Line> selectedLines = new ArrayList<Line>();
private Point dPoint = null;
private Point point1 = null;
private Point point2 = null;
private Point point3 = null;
private Point point4 = null;
private Point p = null;
private Line sLine = null;
private int w, h;
private int r,g,b;
///////////////////////////////////////////////
//In setup und draw gibt es nicht viel zu tun!
///////////////////////////////////////////////
void setup() {
 w = 800; h = 800;
 surface.setSize(w,h);
}

void draw() {
  background(255);
 
  for (GeoObject go : geoObjects ) {
    go.display(); 
  } 
  gitterZeichnen(); 
}
//Das Gitter hilft der Orientierung in der Zeichenebene 
private void gitterZeichnen(){
  strokeWeight(1);
  stroke(200);
  for( int i =0; i<1000;i+=100){
    line(i,0,i,800);
  }
  for( int j =0; j<1000;j+=100){
    line(0,j,1000,j);
  }  
}

//Wird in der Nähe eines vorhandenen Punktes links-geklickt,...
//Die mousePressed-Methode ist im Skript ausführich erklärt
void mousePressed() {  
  if( mouseButton == LEFT){
  dPoint = null;
  for (GeoObject go : geoObjects ) {
    if (go instanceof Point ){
      Point p = (Point) go;
      double d = p.abstandZu(mouseX, mouseY);
      if (d < 6 &&  !fixPoints.contains(p)) {
        dPoint = p; 
      }
    } 
  }  
  if (dPoint == null) {
    Point newPoint = new Point(mouseX, mouseY);
    newPoint.setfarbe(color(r,g,b));//kann weggelassen werden, wenn Punkte grundsätzlich schwarz gezeichnet werden sollen
    geoObjects.add(newPoint);    
  }  else {
     if(keyPressed == true && key == TAB){
        if (dPoint.getSelected()) {
          dPoint.setSelected(false);
          selectedPoints.remove(dPoint);
        } else {
          dPoint.setSelected(true);
          selectedPoints.add(dPoint);
        }
     }    
   }
  }
  //Gerade markieren
  if( mouseButton == RIGHT){
  sLine = null;
  for (GeoObject go : geoObjects ) {
    if (go instanceof Line){
      Line l = (Line) go;
      int x5 =l.getP5().getX();int y5 =l.getP5().getY();
      int x6 =l.getP6().getX();int y6 =l.getP6().getY();
     
      double d = Math.abs(l.yWert(x5,y5,x6,y6,mouseX)- mouseY); 
     
      if (d <60) {  println(d);
        sLine = l; 
        if (sLine.getSelected()) {
            sLine.setSelected(false);
            selectedLines.remove(sLine);
            println("oben");
          } else {
            sLine.setSelected(true);
            selectedLines.add(sLine); 
            println("unten");
        }
      }      
    } 
   }
   //Dient nur der Kontrolle
  println("sPs:  "+selectedPoints.size()+"  sLs:  "+selectedLines.size()); 
  if(selectedLines.size()==2){println(selectedLines.get(0).getP5().getY()); println(selectedLines.get(1).getP5().getY());}
  }
  
}
//Methode sorgt dafür, dass beim Löschen eines Punktes keine Lines ohne Punkte gezeichnet werden          
public void deleteObjects(){
   ArrayList<GeoObject> objekteZuLoeschen = new ArrayList<GeoObject>();
   for (Point p : selectedPoints) {     
      objekteZuLoeschen.add(p);             
      for (GeoObject o : geoObjects) { 
        if (o.abhaengigVon(p)) {         
          objekteZuLoeschen.add(o);        
        } 
       }
      }                                                     
   for (GeoObject o : objekteZuLoeschen) {   
      geoObjects.remove(o);           
   } 
}

 //Der Punkt wird zum dPoint und kann verschoben werden 
 //Aber nur dann, wenn nicht eine Gerade markiert werden soll( rechter Mause-Button).
public void mouseDragged() {
  if(dPoint != null  && ! (mouseButton == RIGHT)) {
    dPoint.setX(mouseX);
    dPoint.setY(mouseY);
  } 
}


//Damit wählt man das zu zeichnende Objekt bzw. die Farbe des Objekts 
void keyPressed(){
  //Farbwahl
  if(key == 'R'){r = 255;}
  if(key == 'G'){g = 255;}
  if(key == 'B'){b = 255;}
  if(key == 'Z'){r=0; g=0; b=0;}
  //Strecke (Line) erzeugen
  if (key == 'l'){              
   if (selectedPoints.size() == 2) {
      Line line = new Line(selectedPoints.get(0), selectedPoints.get(1));
      line.setfarbe(color(r,g,b));
      geoObjects.add(line);
    } 
    selectedPointsLoeschen();
  } 
  //Gerade (StraightLine) erzeugen
  if (key == 'g'){
   if (selectedPoints.size() == 2) {
      StraightLine gerade = new StraightLine(selectedPoints.get(0), selectedPoints.get(1));
      gerade.setfarbe(color(r,g,b));
      geoObjects.add(gerade);
    } 
    selectedPointsLoeschen();
  } 
  
  //Mittelsenkrecht erzeugen 
  if (key == 'm'){
    if (selectedPoints.size() == 2) {
      StraightLineMS msenkrechte = new StraightLineMS(selectedPoints.get(0), selectedPoints.get(1));
      msenkrechte.setfarbe(color(r,g,b));
      geoObjects.add(msenkrechte);
    } 
    selectedPointsLoeschen();
  } 
  
  //Seitenhalbierende erzeugen
  if (key == 'h'){
   if (selectedPoints.size() == 3) {
      StraightLineSH shalbierende = new StraightLineSH(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      shalbierende.setfarbe(color(r,g,b));
      geoObjects.add(shalbierende);
      geoObjects.add(shalbierende.getP4());
    }   
    selectedPointsLoeschen();
  } 
  //Rechteck erzeugen
  if (key == 'r'){
   if (selectedPoints.size() == 2) {
      Rectangle rechteck = new Rectangle(selectedPoints.get(0), selectedPoints.get(1));
      rechteck.setfarbe(color(r,g,b));
      geoObjects.add(rechteck);
    } 
    selectedPointsLoeschen();
  } 
  //Kreis erzeugen
  if (key == 'c'){
   if (selectedPoints.size() == 2) {
      CircleLine kreis = new CircleLine(selectedPoints.get(0), selectedPoints.get(1));
      kreis.setfarbe(color(r,g,b));
      geoObjects.add(kreis);
    } 
    selectedPointsLoeschen();
  } 
  //Ellipse erzeugen
  if (key == 'e'){
   if (selectedPoints.size() == 3) {
      EllipseLine ellipse = new EllipseLine(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      ellipse.setfarbe(color(r,g,b));
      geoObjects.add(ellipse);
    } 
    selectedPointsLoeschen();
  } 
  //Polygon erzeugen
  if (key == 'y'){
   if (selectedPoints.size() >= 3) {    
      Polygon poly = new Polygon(selectedPoints);
      poly.setfarbe(color(r,g,b));
      geoObjects.add(poly);
    } 
    selectedPointsLoeschen();
  } 
  //Parallele erzeugen
  if (key == 'p'){
   if (selectedPoints.size() == 3) {
     
      ParallelLine parallele = new ParallelLine(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      parallele.setfarbe(color(r,g,b));
      geoObjects.add(parallele);
    } 
    selectedPointsLoeschen();
  } 
  //Winkelhalbierende erzeugen
 if (key == 'w'){
   if (selectedPoints.size() == 3) {
      StraightLineWH winkelhalbierende = new StraightLineWH(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      winkelhalbierende.setfarbe(color(r,g,b));
      geoObjects.add(winkelhalbierende);
    } 
    selectedPointsLoeschen();
  } 
  //Lot erzeugen
  if (key == 'o'){
   if (selectedPoints.size() == 3) {
      PerpendicularLine lot= new PerpendicularLine(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      lot.setfarbe(color(r,g,b));
      geoObjects.add(lot);
    } 
    selectedPointsLoeschen();
  } 
  //Schnittobjekt erzeugen
  if (key == 'q'){
     if (selectedLines.size() == 2){ 
       
       point1 = selectedLines.get(0).getP5();point2 = selectedLines.get(0).getP6();
       
       point3 = selectedLines.get(1).getP5();point4 = selectedLines.get(1).getP6(); 
      
       selectedLinesLoeschen(); 
    
    
       CutObject cut = new CutObject(point1,point2,point3,point4);
       cut.setfarbe(color(r,g,b));
       geoObjects.add(cut);
   
     
     } 
  }
  //VertexCurve erzeugen
   if (key == 'v'){
   if (selectedPoints.size() >= 4) {    
      VertexCurve vertexCurve = new VertexCurve(selectedPoints);
     // Farbe ist fest eingestellt
      geoObjects.add(vertexCurve);
    } 
    selectedPointsLoeschen();
  } 
  
  //BezierCurve erzeugen
   if (key == 'x'){
   if (selectedPoints.size() == 4) {    
      BezierCurve bezierCurve = new BezierCurve(selectedPoints);
     // Farbe ist fest eingestellt
      geoObjects.add(bezierCurve);
    } 
    selectedPointsLoeschen();
  } 
  
  
  // Neuen Punkt an Gerade binden
  if (key == 'b'){ 
     if (selectedLines.size() == 1 && selectedPoints.size()==1){ 
       p = selectedPoints.get(0); geoObjects.add(p);
      selectedLines.get(0).setPointP7(p);  
      geoObjects.remove(selectedPoints.get(0));
       selectedLinesLoeschen();
      selectedPointsLoeschen();     
     }
  } 
  //Punkt löschen
  if (key == 'd'){
   if (selectedPoints.size() >= 0) {
      deleteObjects();
    } 
    selectedPointsLoeschen();
   } 
  
}//Ende keyPressed()



//markierte Punkte löschen
private void selectedPointsLoeschen(){
 for (Point p: selectedPoints) {
      p.setSelected(false);
 } 
 selectedPoints.clear();
 }
 //markierte Geraden löschen
 private void selectedLinesLoeschen(){
 for (Line l: selectedLines) {
      l.setSelected(false);
 } 
  selectedLines.clear();
 }


 

   
    

 
 
 
 
 
 
 
